<?php
/**
 * Copy a file, or recursively copy a folder and its contents
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     1.0.1
 * @link        http://aidanlister.com/repos/v/function.copyr.php
 * @param       string   $source    Source path
 * @param       string   $dest      Destination path
 * @return      bool     Returns TRUE on success, FALSE on failure
 */
function copyr($source, $dest)
{
    // Simple copy for a file
    if (is_file($source)) {
        return copy($source, $dest);
    }

    // Make destination directory
    if (!is_dir($dest)) {
        mkdir($dest);
    }

    // Loop through the folder
    $dir = dir($source);
    while (false !== $entry = $dir->read()) {
        // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }

        // Deep copy directories
        if ($dest !== "$source/$entry") {
            copyr("$source/$entry", "$dest/$entry");
        }
    }

    // Clean up
    $dir->close();
    return true;
}

function infuse($dir){
global $db_prefix;
$infusion = stripinput($dir);
	if (file_exists(INFUSIONS.$infusion."/infusion.php")) {
		include INFUSIONS.$infusion."/infusion.php";
		$result = dbquery("SELECT * FROM ".$db_prefix."infusions WHERE inf_folder='$inf_folder'");
		if (dbrows($result)) {
			$data = dbarray($result);
			if ($inf_version > $data['inf_version']) {
				if ($inf_altertables >= 1) {
					for ($i=1;$i < ($inf_altertables+1);$i++) $result = dbquery("ALTER TABLE ".$db_prefix.$inf_altertable_[$i]);
				}
				$result2 = dbquery("UPDATE ".$db_prefix."infusions SET inf_version='$inf_version' WHERE inf_id='".$data['inf_id']."'");
				return TRUE;
			} else {
				return TRUE;
			}
		} else {
			if ($inf_admin_panel != "") {
				if ($inf_admin_image == "") $inf_admin_image = "infusion_panel.gif";
				$result = dbquery("INSERT INTO ".$db_prefix."admin (admin_rights, admin_image, admin_title, admin_link, admin_page) VALUES ('IP', '$inf_admin_image', '$inf_title', '../infusions/$inf_folder/$inf_admin_panel', '4')");
			}
			if ($inf_link_name != "") {
				$link_order = dbresult(dbquery("SELECT MAX(link_order) FROM ".$db_prefix."site_links"),0)+1;
				$result = dbquery("INSERT INTO ".$db_prefix."site_links (link_name, link_url, link_visibility, link_position, link_window, link_order) VALUES ('$inf_link_name', 'infusions/".$inf_folder."/".$inf_link_url."', '$inf_link_visibility', '1', '0', '$link_order')");
			}
			if ($inf_newtables >= 1) {
				for ($i=1;$i < ($inf_newtables+1);$i++) $result = dbquery("CREATE TABLE ".$db_prefix.$inf_newtable_[$i]);
			}
			if ($inf_insertdbrows >= 1) {
				for ($i=1;$i < ($inf_insertdbrows+1);$i++) $result = dbquery("INSERT INTO ".$db_prefix.$inf_insertdbrow_[$i]);
			}
			$result = dbquery("INSERT INTO ".$db_prefix."infusions (inf_title, inf_folder, inf_version) VALUES ('$inf_title', '$inf_folder', '$inf_version')");
			return TRUE;
		}
	} else {
		return FALSE;
	}
}

function deploy_theme($dir, $name, $post){
if($_POST[$post]){
$copy = copyr(INFUSIONS."deploy/packages/".$dir, THEMES);
if($copy){
echo "The ".$name." was installed.<br>";
} else {
echo "The ".$name." wasn't installed<br>";
}
return TRUE;
}
}

$default = array(".", "..");
$default2 = INFUSIONS."deploy/temp/";

function cleanup($target, $exceptions, $output=true)
{
   $sourcedir = opendir($target);
   while(false !== ($filename = readdir($sourcedir)))
   {
       if(!in_array($filename, $exceptions))
       {
           if($output)
           { echo "Processing: ".$target."/".$filename."<br>"; }
           if(is_dir($target."/".$filename))
           {
               // recurse subdirectory; call of function recursive
               cleanup($target."/".$filename, $exceptions);
           }
           else if(is_file($target."/".$filename))
           {
               // unlink file
               unlink($target."/".$filename);
           }
       }
   }
   closedir($sourcedir);
   if($target !== INFUSIONS."deploy/temp/"){
   $result = rmdir($target);
   }
   if($result)
   { return true; }
   else
   { return false; }
}

// Get ZIP extraction functions
include('pclzip.lib.php');

function get_package($name, $folder, $type=mod, $custom=""){
// Download and write package file to TEMP folder
$package = implode('', file("http://deploy.cgeagles.com/packages/".$name));
$FileName = INFUSIONS."deploy/temp/".$name;
$FileHandle = fopen($FileName, 'w');
fwrite($FileHandle, $package);
fclose($FileHandle);
// Extract .ZIP file
$archive = new PclZip(INFUSIONS."deploy/temp/".$name);
$archive->extract(PCLZIP_OPT_PATH, INFUSIONS."deploy/temp/");
// Then copy to infusions folder
$target = INFUSIONS;
if($type == "theme") $target = THEMES;
if($custom !== "") $target = $custom;
$copy = copyr(INFUSIONS."deploy/temp/".$folder."/", $target);
if($copy && $archive !== 0){
return TRUE;
} else {
return FALSE;
}
}
?>